(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     43457,       1372]
NotebookOptionsPosition[     39008,       1213]
NotebookOutlinePosition[     39384,       1230]
CellTagsIndexPosition[     39341,       1227]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Truth tables for a connective C of arity n\
\>", "Section",
 CellChangeTimes->{{3.624569241331855*^9, 3.624569271013935*^9}, {
  3.624569651824555*^9, 3.6245696519031076`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TrueFalseLists", "[", 
   RowBox[{"0", "_"}], "]"}], " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{"{", "}"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.6245693230968523`*^9, 3.6245693331107264`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TrueFalseLists", "[", "n_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ls", " ", ":=", " ", 
       RowBox[{"TrueFalseLists", "[", 
        RowBox[{"n", "-", "1"}], "]"}]}], ",", "ts", ",", "fs"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ts", " ", ":=", " ", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#1", ",", "True"}], "]"}], "&"}], ",", "ls"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"fs", " ", ":=", " ", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#1", ",", "False"}], "]"}], "&"}], ",", "ls"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Join", "[", 
      RowBox[{"ts", ",", "fs"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.624569335111685*^9, 3.624569424602564*^9}, {
  3.6245695843878307`*^9, 3.624569594427977*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TTAux", "[", 
   RowBox[{"C_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Append", "[", 
      RowBox[{"#", ",", 
       RowBox[{"Apply", "[", 
        RowBox[{"C", ",", "#"}], "]"}]}], "]"}], "&"}], ",", 
    RowBox[{"TrueFalseLists", "[", "n", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.624569255802269*^9, 3.624569320929171*^9}, {
  3.624569479496357*^9, 3.6245695144538927`*^9}, {3.624569552156375*^9, 
  3.6245695766316757`*^9}, {3.624569622113554*^9, 3.624569623469552*^9}, {
  3.6245696843104477`*^9, 3.624569690408346*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TT", "[", 
   RowBox[{"C_", ",", "n_"}], "]"}], " ", ":=", " ", 
  RowBox[{"TableForm", "[", 
   RowBox[{"TTAux", "[", 
    RowBox[{"C", ",", "n"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.624569656299148*^9, 3.6245696944962673`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Truth tables for and, or not and implies\
\>", "Section",
 CellChangeTimes->{{3.624569642529216*^9, 3.624569653760825*^9}, {
  3.624569721634305*^9, 3.624569732002912*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"And", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.624569732644668*^9, 3.624569734749752*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "False"},
    {"True", "False", "False"},
    {"False", "False", "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6245697353768387`*^9, 3.626635013637388*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"Or", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.62456973736978*^9, 3.624569738486389*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "True"},
    {"True", "False", "True"},
    {"False", "False", "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.624569738884735*^9, 3.6266350136816473`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"Not", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.6245697400324917`*^9, 3.624569741511305*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "False"},
    {"False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6245697419162292`*^9, 3.626635013753764*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"Implies", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{
  3.624569218224278*^9, {3.6245694734786787`*^9, 3.624569475919305*^9}, {
   3.624569522158186*^9, 3.624569532008934*^9}, {3.624569630661974*^9, 
   3.624569635647654*^9}, {3.6245696720245743`*^9, 3.624569707648548*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "True"},
    {"True", "False", "False"},
    {"False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6245697080467873`*^9, 3.624569751954908*^9, 
  3.626635013799423*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["If and only if", "Subsection",
 CellChangeTimes->{{3.6245698073717737`*^9, 3.624569822976507*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IFF", "[", 
    RowBox[{"True", ",", "True"}], "]"}], ":=", "True"}], ";", " ", 
  RowBox[{
   RowBox[{"IFF", "[", 
    RowBox[{"True", ",", " ", "False"}], "]"}], " ", ":=", " ", "False"}], 
  ";", " ", 
  RowBox[{
   RowBox[{"IFF", "[", 
    RowBox[{"False", ",", "True"}], "]"}], " ", ":=", " ", "False"}], ";", 
  " ", 
  RowBox[{
   RowBox[{"IFF", "[", 
    RowBox[{"False", ",", "False"}], "]"}], " ", ":=", " ", 
   "True"}]}]], "Input",
 CellChangeTimes->{{3.624569824142222*^9, 3.6245698491677437`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"IFF", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.62456985060573*^9, 3.6245698532876472`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "False"},
    {"True", "False", "False"},
    {"False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.624569853684012*^9, 3.626635014015876*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The following are tautologies", "Section",
 CellChangeTimes->{{3.6245697142761393`*^9, 3.6245697195540857`*^9}, {
  3.624569761807053*^9, 3.624569770921513*^9}, {3.6245708932677593`*^9, 
  3.624570904795127*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Contrapositive", "[", 
   RowBox[{"P_", ",", "Q_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"P", " ", "~", "Implies", "~", " ", "Q"}], ")"}], "~", "IFF", "~", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Not", "[", "Q", "]"}], "~", "Implies", "~", 
     RowBox[{"Not", "[", "P", "]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.624569213094117*^9, 3.624569216159871*^9}, {
  3.624569773114635*^9, 3.6245697993342*^9}, {3.6245698592005243`*^9, 
  3.624569873697818*^9}, {3.624570143843148*^9, 3.62457018335277*^9}, {
  3.6245708328900337`*^9, 3.624570838075453*^9}, {3.624571716846896*^9, 
  3.624571718941716*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeMorgan", "[", 
   RowBox[{"P_", ",", "Q_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Not", "[", 
    RowBox[{"P", "~", "And", "~", "Q"}], "]"}], "~", "IFF", "~", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Not", "[", "P", "]"}], "~", "Or", "~", 
     RowBox[{"Not", "[", "Q", "]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.6245708390045757`*^9, 3.624570871975079*^9}, {
  3.624571747532403*^9, 3.624571748955323*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Chain", "[", 
   RowBox[{"P_", ",", "Q_", ",", "R_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"P", " ", "~", "Implies", "~", "Q"}], ")"}], "~", "And", "~", 
     RowBox[{"(", 
      RowBox[{"Q", "~", "Implies", "~", "R"}], ")"}]}], ")"}], "~", "Implies",
    "~", 
   RowBox[{"(", 
    RowBox[{"Q", "~", "Implies", "~", "R"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.62456991544403*^9, 3.624569951759197*^9}, 
   3.624569985003148*^9, {3.6245701457728853`*^9, 3.6245701936997147`*^9}, {
   3.624571760349658*^9, 3.6245717619336977`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Curry", "[", 
   RowBox[{"P_", ",", "Q_", ",", "R_"}], "]"}], " ", ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"P", " ", "~", "Implies", "~", "Q"}], ")"}], "~", "Implies", 
     "~", "R"}], ")"}], "~", "Implies", "~", 
   RowBox[{"(", 
    RowBox[{"P", " ", "~", "Implies", "~", 
     RowBox[{"(", 
      RowBox[{"Q", "~", "Implies", "~", "R"}], ")"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.624569994861136*^9, 3.624570060823038*^9}, {
  3.624570137822567*^9, 3.6245702052597017`*^9}, {3.6245703954665117`*^9, 
  3.6245704074120092`*^9}, {3.624570571379715*^9, 3.624570576915629*^9}, {
  3.624571881326776*^9, 3.6245719366078043`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SCurry", "[", 
   RowBox[{"P_", ",", "Q_", ",", "R_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"P", " ", "~", "Implies", "~", "Q"}], ")"}], "~", "Implies", 
     "~", "R"}], ")"}], "~", "Implies", "~", 
   RowBox[{"(", 
    RowBox[{"Q", "~", "Implies", "~", "R"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.624615581889814*^9, 3.624615600356291*^9}, {
  3.624615679924592*^9, 3.624615691129722*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"Contrapositive", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.6245708796838083`*^9, 3.624570881480839*^9}, {
  3.624571898753673*^9, 3.624571902249054*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "True"},
    {"True", "False", "True"},
    {"False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6245708820332527`*^9, 3.626635014273643*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"DeMorgan", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.6245698756579514`*^9, 3.624569880547579*^9}, {
  3.624570210628992*^9, 3.624570210851767*^9}, {3.6245719398717213`*^9, 
  3.6245719420458612`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "True"},
    {"True", "False", "True"},
    {"False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.624569881048292*^9, 3.624570211197283*^9, 
  3.624570877027274*^9, 3.6245719427551193`*^9, 3.626635014352792*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"Chain", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.624569987882204*^9, 3.624569989418288*^9}, {
  3.624570212844687*^9, 3.624570213363988*^9}, {3.62457194485588*^9, 
  3.62457194595153*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True", "True"},
    {"False", "True", "True", "True"},
    {"True", "False", "True", "True"},
    {"False", "False", "True", "True"},
    {"True", "True", "False", "True"},
    {"False", "True", "False", "True"},
    {"True", "False", "False", "True"},
    {"False", "False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.624569989807254*^9, 3.62457021377579*^9, 
  3.624571946273231*^9, 3.6266350143932343`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"Curry", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.624570214549402*^9, 3.624570215564052*^9}, {
  3.624571951127377*^9, 3.6245719519448013`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True", "True"},
    {"False", "True", "True", "True"},
    {"True", "False", "True", "True"},
    {"False", "False", "True", "True"},
    {"True", "True", "False", "True"},
    {"False", "True", "False", "True"},
    {"True", "False", "False", "True"},
    {"False", "False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6245702159830093`*^9, 3.6245705938916693`*^9, 
  3.624571952345871*^9, 3.62663501446161*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SCurry", "[", 
  RowBox[{"P", ",", "Q", ",", "R"}], "]"}]], "Input",
 CellChangeTimes->{{3.624615848544714*^9, 3.6246158520802107`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"P", "\[Implies]", "Q"}], ")"}], "\[Implies]", "R"}], ")"}], 
  "\[Implies]", 
  RowBox[{"(", 
   RowBox[{"Q", "\[Implies]", "R"}], ")"}]}]], "Output",
 CellChangeTimes->{3.624615852493422*^9, 3.626635014530053*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"SCurry", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.624615780280229*^9, 3.624615785518581*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True", "True"},
    {"False", "True", "True", "True"},
    {"True", "False", "True", "True"},
    {"False", "False", "True", "True"},
    {"True", "True", "False", "True"},
    {"False", "True", "False", "True"},
    {"True", "False", "False", "True"},
    {"False", "False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6246157859387836`*^9, 3.626635014632471*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Same propositions with Implies replaced with a general connective C\
\>", "Section",
 CellChangeTimes->{{3.6245697142761393`*^9, 3.6245697195540857`*^9}, {
  3.624569761807053*^9, 3.624569770921513*^9}, {3.6245708932677593`*^9, 
  3.624570933879106*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"IFF", "[", "C_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "S", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"A_", ",", "B_"}], "]"}], " ", ":=", " ", 
      RowBox[{
       RowBox[{"C", "[", 
        RowBox[{"A", ",", "B"}], "]"}], "~", "And", "~", 
       RowBox[{"C", "[", 
        RowBox[{"B", ",", "A"}], "]"}]}]}], ";", "S"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.624570968697554*^9, 3.624571083054302*^9}, {
  3.624571345151773*^9, 3.6245713492468157`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Contrapositive", "[", "C_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "S", "}"}], ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"P_", ",", "Q_"}], "]"}], " ", ":=", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"P", " ", "~", "C", "~", " ", "Q"}], ")"}], "~", 
       RowBox[{"IFF", "[", "C", "]"}], "~", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Not", "[", "Q", "]"}], "~", "C", "~", 
         RowBox[{"Not", "[", "P", "]"}]}], ")"}]}]}], ";", " ", "S"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.624569213094117*^9, 3.624569216159871*^9}, {
  3.624569773114635*^9, 3.6245697993342*^9}, {3.6245698592005243`*^9, 
  3.624569873697818*^9}, {3.624570143843148*^9, 3.62457018335277*^9}, {
  3.6245708328900337`*^9, 3.624570838075453*^9}, {3.624570936406262*^9, 
  3.6245709428500233`*^9}, {3.624571116662663*^9, 3.6245711203015738`*^9}, {
  3.624571176429188*^9, 3.624571214916212*^9}, {3.624571341325712*^9, 
  3.6245713511446533`*^9}, {3.6245717077981873`*^9, 3.6245717101102552`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeMorgan", "[", "C_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "S", "}"}], ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"P_", ",", "Q_"}], "]"}], " ", ":=", " ", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"P", "~", "And", "~", "Q"}], "]"}], "~", 
       RowBox[{"IFF", "[", "C", "]"}], "~", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Not", "[", "P", "]"}], "~", "Or", "~", 
         RowBox[{"Not", "[", "Q", "]"}]}], ")"}]}]}], ";", " ", "S"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.624571226662099*^9, 3.624571242248733*^9}, {
  3.624571353297049*^9, 3.6245713540398197`*^9}, {3.624571754134499*^9, 
  3.6245717553588333`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Chain", "[", "C_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "S", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"P_", ",", "Q_", ",", "R_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"P", " ", "~", "C", "~", "Q"}], ")"}], "~", "And", "~", 
         RowBox[{"(", 
          RowBox[{"Q", "~", "C", "~", "R"}], ")"}]}], ")"}], "~", "C", "~", 
       RowBox[{"(", 
        RowBox[{"Q", "~", "C", "~", "R"}], ")"}]}]}], ";", " ", "S"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.62456991544403*^9, 3.624569951759197*^9}, 
   3.624569985003148*^9, {3.6245701457728853`*^9, 3.6245701936997147`*^9}, {
   3.624571129485539*^9, 3.624571149609144*^9}, {3.624571207250607*^9, 
   3.624571207346766*^9}, {3.624571248706847*^9, 3.624571259409052*^9}, {
   3.624571355976453*^9, 3.624571356553678*^9}, {3.6245717661608047`*^9, 
   3.62457176745498*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Curry", "[", "C_", "]"}], " ", ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "S", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"P_", ",", "Q_", ",", "R_"}], "]"}], " ", ":=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"P", " ", "~", "C", "~", "Q"}], ")"}], "~", "C", "~", "R"}],
         ")"}], "~", "C", "~", 
       RowBox[{"(", 
        RowBox[{"P", " ", "~", "C", "~", 
         RowBox[{"(", 
          RowBox[{"Q", "~", "C", "~", "R"}], ")"}]}], ")"}]}]}], ";", " ", 
     "S"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.624569994861136*^9, 3.624570060823038*^9}, {
  3.624570137822567*^9, 3.6245702052597017`*^9}, {3.6245703954665117`*^9, 
  3.6245704074120092`*^9}, {3.624570571379715*^9, 3.624570576915629*^9}, {
  3.6245711331907177`*^9, 3.624571160146697*^9}, {3.624571208379678*^9, 
  3.624571209410692*^9}, {3.624571261538927*^9, 3.624571283542612*^9}, {
  3.624571359249157*^9, 3.62457135996215*^9}, {3.6245719567622957`*^9, 
  3.6245719574993563`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Things that should be tautologies are not if we use the wrong definiion of \
implication\
\>", "Section",
 CellChangeTimes->{{3.6245713968146143`*^9, 3.624571435265011*^9}}],

Cell[CellGroupData[{

Cell["\<\
BadImp: false statements do not imply true statements but otherwise as => \
(same as exclusive or)\
\>", "Subsection",
 CellChangeTimes->{{3.6245715760729322`*^9, 3.624571611620184*^9}, {
  3.6245716484975777`*^9, 3.624571666285191*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BadImp", "[", 
    RowBox[{"True", ",", "True"}], "]"}], ":=", "True"}], ";", " ", 
  RowBox[{
   RowBox[{"BadImp", "[", 
    RowBox[{"True", ",", "False"}], "]"}], ":=", "False"}], ";", 
  RowBox[{
   RowBox[{"BadImp", "[", 
    RowBox[{"False", ",", "True"}], "]"}], ":=", "False"}], ";", " ", 
  RowBox[{
   RowBox[{"BadImp", "[", 
    RowBox[{"False", ",", "False"}], "]"}], ":=", "True"}]}]], "Input",
 CellChangeTimes->{{3.624571612788908*^9, 3.62457163761723*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"BadImp", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.624571639666555*^9, 3.6245716445785933`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "False"},
    {"True", "False", "False"},
    {"False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.6245716423206863`*^9, 3.6245716449567623`*^9}, 
   3.626635014978891*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"IFF", "[", "BadImp", "]"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.624571676267754*^9, 3.624571685055562*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "False"},
    {"True", "False", "False"},
    {"False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.624571682653633*^9, 3.624571685451255*^9}, 
   3.6266350150286837`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"Contrapositive", "[", "BadImp", "]"}], ",", "2"}], "]"}]], "Input",\

 CellChangeTimes->{{3.624571698994115*^9, 3.624571732350647*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "True"},
    {"True", "False", "True"},
    {"False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.624571732754654*^9, 3.626635015093296*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"DeMorgan", "[", "BadImp", "]"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.6245719604964437`*^9, 3.6245719677388763`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "True"},
    {"True", "False", "True"},
    {"False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.624571968226473*^9, 3.626635015161368*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"Chain", "[", "BadImp", "]"}], ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.6245719696659393`*^9, 3.624571978324307*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True", "True"},
    {"False", "True", "True", "False"},
    {"True", "False", "True", "True"},
    {"False", "False", "True", "True"},
    {"True", "True", "False", "True"},
    {"False", "True", "False", "True"},
    {"True", "False", "False", "False"},
    {"False", "False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.624571975599104*^9, 3.624571978662157*^9}, 
   3.626635015216611*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"Curry", "[", "BadImp", "]"}], ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.624571986235931*^9, 3.624571990846075*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True", "True"},
    {"False", "True", "True", "True"},
    {"True", "False", "True", "True"},
    {"False", "False", "True", "True"},
    {"True", "True", "False", "True"},
    {"False", "True", "False", "True"},
    {"True", "False", "False", "True"},
    {"False", "False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6245719912372704`*^9, 3.626635015281934*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
WorseImp: false statements do not imply anything, otherwise as =>\
\>", "Subsection",
 CellChangeTimes->{{3.6245715760729322`*^9, 3.624571611620184*^9}, {
  3.6245716484975777`*^9, 3.624571666285191*^9}, {3.624572006145396*^9, 
  3.624572018727735*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"WorseImp", "[", 
    RowBox[{"True", ",", "True"}], "]"}], ":=", "True"}], ";", " ", 
  RowBox[{
   RowBox[{"WorseImp", "[", 
    RowBox[{"True", ",", "False"}], "]"}], ":=", "False"}], ";", 
  RowBox[{
   RowBox[{"WorseImp", "[", 
    RowBox[{"False", ",", "True"}], "]"}], ":=", "False"}], ";", 
  RowBox[{
   RowBox[{"WorseImp", "[", 
    RowBox[{"False", ",", "False"}], "]"}], ":=", "False"}]}]], "Input",
 CellChangeTimes->{{3.624572029183502*^9, 3.624572063419449*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"WorseImp", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.624571639666555*^9, 3.6245716445785933`*^9}, {
  3.624572066674035*^9, 3.624572067824657*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "False"},
    {"True", "False", "False"},
    {"False", "False", "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.6245716423206863`*^9, 3.6245716449567623`*^9}, 
   3.624572068457383*^9, 3.626635015363804*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"IFF", "[", "WorseImp", "]"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.624571676267754*^9, 3.624571685055562*^9}, {
  3.624572071042164*^9, 3.6245720730336523`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True"},
    {"False", "True", "False"},
    {"True", "False", "False"},
    {"False", "False", "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.624571682653633*^9, 3.624571685451255*^9}, 
   3.6245720733882847`*^9, 3.626635015400928*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"Contrapositive", "[", "WorseImp", "]"}], ",", "2"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.624571698994115*^9, 3.624571732350647*^9}, {
  3.6245720776134853`*^9, 3.624572078675537*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "False"},
    {"False", "True", "False"},
    {"True", "False", "False"},
    {"False", "False", "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.624571732754654*^9, 3.624572079098082*^9, 
  3.626635015453846*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"DeMorgan", "[", "WorseImp", "]"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.6245719604964437`*^9, 3.6245719677388763`*^9}, {
  3.624572084668943*^9, 3.624572087427792*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "False"},
    {"False", "True", "True"},
    {"True", "False", "True"},
    {"False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.624571968226473*^9, 3.624572087807126*^9, 
  3.6266350155044203`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"Chain", "[", "WorseImp", "]"}], ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.6245719696659393`*^9, 3.624571978324307*^9}, {
  3.624572090446458*^9, 3.62457209157339*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True", "True"},
    {"False", "True", "True", "False"},
    {"True", "False", "True", "False"},
    {"False", "False", "True", "False"},
    {"True", "True", "False", "False"},
    {"False", "True", "False", "False"},
    {"True", "False", "False", "False"},
    {"False", "False", "False", "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.624571975599104*^9, 3.624571978662157*^9}, 
   3.624572092123355*^9, 3.6266350155578527`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{
   RowBox[{"Curry", "[", "WorseImp", "]"}], ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.624571986235931*^9, 3.624571990846075*^9}, {
  3.624572095064084*^9, 3.624572097181313*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True", "True"},
    {"False", "True", "True", "False"},
    {"True", "False", "True", "False"},
    {"False", "False", "True", "False"},
    {"True", "True", "False", "False"},
    {"False", "True", "False", "False"},
    {"True", "False", "False", "False"},
    {"False", "False", "False", "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6245719912372704`*^9, 3.624572097635294*^9, 
  3.626635015608724*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Some other propositions", "Section",
 CellChangeTimes->{{3.6266350460551777`*^9, 3.6266350506036863`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Curry2", "[", 
   RowBox[{"P_", ",", "Q_", ",", "R_"}], "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"P", "~", "Implies", "~", 
     RowBox[{"(", 
      RowBox[{"Q", "~", "Implies", "~", "R"}], ")"}]}], ")"}], "~", "Implies",
    "~", 
   RowBox[{"(", 
    RowBox[{"Q", "~", "Implies", "~", 
     RowBox[{"(", 
      RowBox[{"P", "~", "Implies", "~", "R"}], ")"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.626635064356304*^9, 3.6266350885001307`*^9}, {
  3.626635120002686*^9, 3.6266351500849133`*^9}, {3.626635221048315*^9, 
  3.626635224440645*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TT", "[", 
  RowBox[{"Curry2", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.626635093719654*^9, 3.626635102736486*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"True", "True", "True", "True"},
    {"False", "True", "True", "True"},
    {"True", "False", "True", "True"},
    {"False", "False", "True", "True"},
    {"True", "True", "False", "True"},
    {"False", "True", "False", "True"},
    {"True", "False", "False", "True"},
    {"False", "False", "False", "True"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.626635095352392*^9, 3.6266351290672626`*^9}, 
   3.626635240261499*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["Curry2"], "Input",
 CellChangeTimes->{{3.626635090021796*^9, 3.6266350906906233`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"P", "\[Implies]", 
    RowBox[{"(", 
     RowBox[{"Q", "\[Implies]", "R"}], ")"}]}], ")"}], "\[Implies]", 
  RowBox[{"(", 
   RowBox[{"Q", "\[Implies]", 
    RowBox[{"(", 
     RowBox[{"P", "\[Implies]", "R"}], ")"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.62663509101213*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{740, 552},
WindowMargins->{{Automatic, 2}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 186, 4, 67, "Section"],
Cell[768, 28, 232, 6, 27, "Input"],
Cell[1003, 36, 1038, 29, 73, "Input"],
Cell[2044, 67, 619, 15, 27, "Input"],
Cell[2666, 84, 277, 7, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2980, 96, 182, 4, 67, "Section"],
Cell[CellGroupData[{
Cell[3187, 104, 146, 3, 27, "Input"],
Cell[3336, 109, 695, 19, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4068, 133, 144, 3, 27, "Input"],
Cell[4215, 138, 693, 19, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4945, 162, 148, 3, 27, "Input"],
Cell[5096, 167, 614, 17, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5747, 189, 325, 6, 27, "Input"],
Cell[6075, 197, 718, 20, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6830, 222, 104, 1, 34, "Subsection"],
Cell[6937, 225, 559, 17, 43, "Input"],
Cell[CellGroupData[{
Cell[7521, 246, 147, 3, 27, "Input"],
Cell[7671, 251, 692, 19, 87, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8424, 277, 218, 3, 67, "Section"],
Cell[8645, 282, 677, 15, 27, "Input"],
Cell[9325, 299, 457, 12, 27, "Input"],
Cell[9785, 313, 624, 16, 27, "Input"],
Cell[10412, 331, 714, 17, 27, "Input"],
Cell[11129, 350, 484, 13, 27, "Input"],
Cell[CellGroupData[{
Cell[11638, 367, 208, 4, 27, "Input"],
Cell[11849, 373, 692, 19, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12578, 397, 255, 5, 27, "Input"],
Cell[12836, 404, 761, 20, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13634, 429, 244, 5, 27, "Input"],
Cell[13881, 436, 930, 24, 151, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14848, 465, 199, 4, 27, "Input"],
Cell[15050, 471, 932, 24, 151, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16019, 500, 160, 3, 27, "Input"],
Cell[16182, 505, 298, 9, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16517, 519, 149, 3, 27, "Input"],
Cell[16669, 524, 884, 23, 151, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17602, 553, 264, 5, 67, "Section"],
Cell[17869, 560, 567, 16, 27, "Input"],
Cell[18439, 578, 1121, 25, 27, "Input"],
Cell[19563, 605, 774, 21, 27, "Input"],
Cell[20340, 628, 1007, 25, 27, "Input"],
Cell[21350, 655, 1106, 27, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22493, 687, 183, 4, 89, "Section"],
Cell[CellGroupData[{
Cell[22701, 695, 247, 5, 49, "Subsection"],
Cell[22951, 702, 518, 14, 43, "Input"],
Cell[CellGroupData[{
Cell[23494, 720, 151, 3, 27, "Input"],
Cell[23648, 725, 724, 20, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24409, 750, 180, 4, 27, "Input"],
Cell[24592, 756, 722, 20, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25351, 781, 193, 5, 27, "Input"],
Cell[25547, 788, 690, 19, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26274, 812, 189, 4, 27, "Input"],
Cell[26466, 818, 690, 19, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27193, 842, 184, 4, 27, "Input"],
Cell[27380, 848, 912, 24, 151, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28329, 877, 182, 4, 27, "Input"],
Cell[28514, 883, 884, 23, 151, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29447, 912, 263, 5, 34, "Subsection"],
Cell[29713, 919, 523, 14, 58, "Input"],
Cell[CellGroupData[{
Cell[30261, 937, 202, 4, 27, "Input"],
Cell[30466, 943, 747, 20, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31250, 968, 233, 5, 27, "Input"],
Cell[31486, 975, 745, 20, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32268, 1000, 247, 6, 27, "Input"],
Cell[32518, 1008, 719, 20, 89, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33274, 1033, 240, 5, 27, "Input"],
Cell[33517, 1040, 718, 20, 89, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34272, 1065, 234, 5, 27, "Input"],
Cell[34509, 1072, 941, 24, 151, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35487, 1101, 233, 5, 27, "Input"],
Cell[35723, 1108, 916, 24, 151, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[36700, 1139, 112, 1, 67, "Section"],
Cell[36815, 1142, 604, 16, 27, "Input"],
Cell[CellGroupData[{
Cell[37444, 1162, 149, 3, 27, "Input"],
Cell[37596, 1167, 912, 24, 151, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38545, 1196, 100, 1, 27, "Input"],
Cell[38648, 1199, 332, 10, 27, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
